POJ2886 Who Gets the Most Candies? 【线段树】+【单点更新】+【模拟】+【反素数】

Who Gets the Most Candies?

Time Limit: 5000MS   Memory Limit: 131072K
Total Submissions: 9416   Accepted: 2868
Case Time Limit: 2000MS

Description

N children are sitting in a circle to play a game.

The children are numbered from 1 to N in clockwise order. Each of them has a card with a non-zero integer on it in his/her hand. The game starts from the K-th child, who tells all the others the integer on his card and jumps out of the
circle. The integer on his card tells the next child to jump out. Let A denote the integer. If A is positive, the next child will be the A-th child to the left. If A is negative, the next child will be the (?A)-th
child to the right.

The game lasts until all children have jumped out of the circle. During the game, the p-th child jumping out will get F(p) candies where F(p) is the number of positive integers that perfectly divide p.
Who gets the most candies?

Input

There are several test cases in the input. Each test case starts with two integers N (0 < N ≤ 500,000) and K (1 ≤ K ≤ N) on the first line. The next N lines contains the names of the children
(consisting of at most 10 letters) and the integers (non-zero with magnitudes within 108) on their cards in increasing order of the children’s numbers, a name and an integer separated by a single space in a line with no leading or trailing
spaces.

Output

Output one line for each test case containing the name of the luckiest child and the number of candies he/she gets. If ties occur, always choose the child who jumps out of the circle first.

Sample Input

4 2
Tom 2
Jack 4
Mary -1
Sam 1

Sample Output

Sam 3

泪奔T_T 这题做了一整个上午才过,主要卡在反素数的打表上,打得时候外层循环用的是maxn/2,导致有一半的因子表没有包含自身,因此错了N次,第二个卡点是一个点出圈后更新下个点的位置时总点数是改变的,第三个卡点就是线段树了,维护信息是区间未出圈的点数,在更新完即将出圈点的具体位置后即可直接插入。

//#define DEBUG
#include <stdio.h>
#include <string.h>
#define maxn 500002
#define lson l, mid, rt << 1
#define rson mid + 1, r, rt << 1 | 1

int tree[maxn << 2], div[maxn], temp;
struct Node{
	char name[12];
	int mov;
} stu[maxn], ans;

void countDiv()
{
	int i, j;
	for(i = 1; i <= maxn; ++i)
		for(j = i; j <= maxn; j += i)
			++div[j];
}

void build(int l, int r, int rt)
{
	tree[rt] = r - l + 1;
	if(l == r) return;

	int mid = (l + r) >> 1;
	build(lson);
	build(rson);
}

void update(int pos, int rank, int l, int r, int rt)
{
	--tree[rt];
	if(l == r){
		if(div[rank] > ans.mov){
			ans.mov = div[rank];
			strcpy(ans.name, stu[r].name);
		}
		temp = stu[r].mov;
		return;
	}

	int mid = (l + r) >> 1;
	if(tree[rt << 1] >= pos) update(pos, rank, lson);
	else update(pos - tree[rt << 1], rank, rson);
}

int getK(int k, int n)
{
	if(temp > 0) return (k + temp - 2) % n + 1;
	return ((k + temp - 1) % n + n) % n + 1;
}

int main()
{
	#ifdef DEBUG
	freopen("..\\stdin.txt", "r", stdin);
	freopen("..\\stdout.txt", "w", stdout);
	#endif

	countDiv();
	int n, k, i, rank;

	while(scanf("%d%d", &n, &k) == 2){
		build(1, n, 1);

		for(i = 1; i <= n; ++i)
			scanf("%s%d", stu[i].name, &stu[i].mov);

		rank = 1; ans.mov = 0;

		update(k, rank++, 1, n, 1);
		while(tree[1]){
			k = getK(k, tree[1]);
			update(k, rank++, 1, n, 1);
		}

		printf("%s %d\n", ans.name, ans.mov);
	}
	return 0;
}

POJ2886 Who Gets the Most Candies? 【线段树】+【单点更新】+【模拟】+【反素数】,布布扣,bubuko.com

时间: 2024-10-18 15:12:58

POJ2886 Who Gets the Most Candies? 【线段树】+【单点更新】+【模拟】+【反素数】的相关文章

POJ训练计划2828_Buy Tickets(线段树/单点更新)

解题报告 题意: 插队完的顺序. 思路: 倒着处理数据,第i个人占据第j=pos[i]+1个的空位. 线段树维护区间空位信息. #include <iostream> #include <cstdio> #include <cstring> using namespace std; struct node { int x,v; } num[201000]; int sum[1000000],ans[201000]; void cbtree(int rt,int l,in

HDU2852_KiKi&#39;s K-Number(线段树/单点更新)

解题报告 题目传送门 题意: 意思很好理解. 思路: 每次操作是100000次,数据大小100000,又是多组输入.普通模拟肯定不行. 线段树结点记录区间里存在数字的个数,加点删点操作就让该点个数+1,判断x存在就查询[1,x]区间的个数和[1,x-1]的个数. 求x之后第k大的数就先确定小于x的个数t,第t+k小的数就是要求的. #include <iostream> #include <cstdio> #include <cstring> using namespa

POJ3264_Balanced Lineup(线段树/单点更新)

解题报告 题意: 求区间内最大值和最小值的差值. 思路: 裸线段树,我的线段树第一发.区间最值. #include <iostream> #include <cstring> #include <cstdio> #define inf 99999999 #define LL long long using namespace std; LL minn[201000],maxx[201000]; void update(LL root,LL l,LL r,LL p,LL

HDU1166_敌兵布阵(线段树/单点更新)

解题报告 题意: 略 思路: 线段树单点增减和区间求和. #include <iostream> #include <cstring> #include <cstdio> #define LL long long using namespace std; int sum[201000]; void update(int root,int l,int r,int p,int v) { int mid=(l+r)/2; if(l==r)sum[root]+=v; else

HDU1754_I Hate It(线段树/单点更新)

解题报告 题意: 略 思路: 单点替换,区间最值 #include <iostream> #include <cstring> #include <cstdio> #define inf 99999999 using namespace std; int maxx[808000]; void update(int root,int l,int r,int p,int v) { int mid=(l+r)/2; if(l==r)maxx[root]=v; else if(

Uva 12299 RMQ with Shifts(线段树 + 单点更新 )

Uva 12299 RMQ with Shifts (线段树 + 单点更新) 题意: 对于给定的序列 x[i]给出一个操作 shift(a,b,c,d,e) 对应的是将 x[a]与x[b] x[b]与x[c] 这样相邻的两两交换For example, if A={6, 2, 4, 8, 5, 1, 4}then shift(2, 4, 5, 7) yields {6, 8, 4, 5, 4, 1, 2}. After that,shift(1, 2) yields {8, 6, 4, 5, 4

POJ2352_Stars(线段树/单点更新)

解题报告 题意: 坐标系中,求每颗星星的左下角有多少星星. 思路: 把横坐标看成区间,已知输入是先对y排序再对x排序,每次加一个点先查询该点x坐标的左端有多少点,再更新点. #include <iostream> #include <cstdio> #include <cstring> using namespace std; int sum[200000]; struct node { int x,y; } p[20000]; void push_up(int roo

HDU 1754 I Hate It (线段树 单点更新)

题目链接 中文题意,与上题类似. 1 #include <iostream> 2 #include <cstdio> 3 #include <cstring> 4 #include <queue> 5 #include <cstdlib> 6 #include <algorithm> 7 const int maxn = 200000+10; 8 using namespace std; 9 int a[maxn], n, m; 10

HDU 1166 敌兵布阵(线段树单点更新,板子题)

敌兵布阵 Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 87684    Accepted Submission(s): 36912 Problem Description C国的死对头A国这段时间正在进行军事演习,所以C国间谍头子Derek和他手下Tidy又开始忙乎了.A国在海岸线沿直线布置了N个工兵营地,Derek和Tidy的任务

Minimum Inversion Number(线段树单点更新+逆序数)

Minimum Inversion Number(线段树单点更新+逆序数) Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u Submit Status Description The inversion number of a given number sequence a1, a2, ..., an is the number of pairs (ai, aj) that satisfy